/* classe che realizza la finestra di dialogo per il setting del riferimento
ad un altro agente del gruppo */

import java.awt.*;
import java.awt.event.*;

public class DialogAddAgent extends Dialog
                 implements ActionListener {

    private String defaultPort="1099";
    private AgentFrame parent;
    private agentServer server;

	public DialogAddAgent(AgentFrame parent, agentServer server, boolean modal) {
	    super(parent, modal);
	    this.parent=parent;
	    this.server=server;
		setLayout(null);
		addNotify();
		setSize(getInsets().left + getInsets().right + 497,getInsets().top + getInsets().bottom + 303);
		setFont(new Font("Dialog", Font.BOLD, 14));
		setForeground(Color.black);
		setBackground(Color.lightGray);
		labelName = new Label("Agent name");
		labelName.setBounds(getInsets().left + 60,getInsets().top + 24,120,24);
		add(labelName);
		textFieldName = new TextField();
		textFieldName.setBounds(getInsets().left + 204,getInsets().top + 24,182,24);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		add(textFieldName);
		labelMachine = new Label("Host machine");
		labelMachine.setBounds(getInsets().left + 60,getInsets().top + 72,120,24);
		setFont(new Font("Dialog", Font.BOLD, 14));
		add(labelMachine);
		textFieldHost = new TextField();
		textFieldHost.setBounds(getInsets().left + 204,getInsets().top + 72,183,23);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		add(textFieldHost);
		labelPort = new Label("Port number");
		labelPort.setBounds(getInsets().left + 60,getInsets().top + 120,120,24);
		setFont(new Font("Dialog", Font.BOLD, 14));
		add(labelPort);
		textFieldPort = new TextField(defaultPort);
		textFieldPort.setBounds(getInsets().left + 204,getInsets().top + 120,183,23);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		add(textFieldPort);
		buttonOk = new Button("Ok");
		buttonOk.addActionListener(this);
		buttonOk.setBounds(getInsets().left + 84,getInsets().top + 204,120,36);
		setFont(new Font("Dialog", Font.BOLD, 14));
		add(buttonOk);
		buttonCancel = new Button("Cancel");
		buttonCancel.addActionListener(this);
		buttonCancel.setBounds(getInsets().left + 264,getInsets().top + 204,120,36);
		add(buttonCancel);
		setTitle("Add agent to the bunch");
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().getBounds();
    	Rectangle abounds = getBounds();

    	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == buttonOk) {
	        buttonOk_Clicked();
        } else
        if (source == buttonCancel) {
            setVisible(false);
        }
	}

	void buttonOk_Clicked() {
		setVisible(false);
	    server.otherAgentName.addElement(textFieldName.getText());
	    server.otherMachine.addElement(textFieldHost.getText());
	    server.otherRegistry.addElement(textFieldPort.getText());
	    server.numberOfAgent++;
	    System.out.println("Aggiunto l'agente "+textFieldName.getText()+" sulla macchina");
	    System.out.println("Number of agent vale "+server.numberOfAgent);
	}

	Label labelName,labelPort,labelMachine;
	TextField textFieldName,textFieldHost,textFieldPort;
	Button buttonOk,buttonCancel;
}
