/* classe che realizza la finestra di dialogo per il setting del nome dell'agente
e per far partire il server dell'agente */

import java.rmi.registry.*;
import java.rmi.*;
import java.rmi.server.*;
import java.awt.*;
import java.awt.event.*;

public class DialogNameAgent extends Dialog
          implements ActionListener {

    private AgentFrame parentFrame;
    private agentServer server;
    private String defaultPort="1099";

	public DialogNameAgent(AgentFrame parent, agentServer server, boolean modal) {
         super(parent, modal);
         parentFrame=parent;
         this.server=server;
         setLayout(null);
         addNotify();
         setSize(getInsets().left + getInsets().right + 497,getInsets().top + getInsets().bottom + 303);
         setFont(new Font("Dialog", Font.BOLD, 14));
         setForeground(Color.black);
		 setBackground(Color.lightGray);
         labelAgent = new Label("Agent name");
         labelAgent.setBounds(getInsets().left + 36,getInsets().top + 24,108,24);
         add(labelAgent);
         if (server.serverRunning) {
            textFieldAgent = new TextField(server.nameAgent);
         } else { textFieldAgent = new TextField(); }
         textFieldAgent.setBounds(getInsets().left + 168,getInsets().top + 24,204,24);
         textFieldAgent.setFont(new Font("Dialog", Font.PLAIN, 14));
         add(textFieldAgent);
         labelMachine1 = new Label("Host machine");
         labelMachine1.setBounds(getInsets().left + 36,getInsets().top + 72,108,24);
         add(labelMachine1);
         labelMachine2 = new Label(server.hostMachine);
         labelMachine2.setBounds(getInsets().left + 168,getInsets().top + 72,204,24);
         add(labelMachine2);
         labelPort = new Label("Port number");
         labelPort.setBounds(getInsets().left + 36,getInsets().top + 120,108,24);
         add(labelPort);
         if (server.serverRunning) {
            textFieldPort = new TextField(Integer.toString(server.reg));
            textFieldPort.disable();
         } else { textFieldPort = new TextField(defaultPort); }
         textFieldPort.setBounds(getInsets().left + 168,getInsets().top + 120,204,24);
         textFieldPort.setFont(new Font("Dialog", Font.PLAIN, 14));
         add(textFieldPort);
         buttonCancel = new Button("Cancel");
         buttonCancel.addActionListener(this);
         buttonCancel.setBounds(getInsets().left + 264,getInsets().top + 204,132,36);
         buttonCancel.setFont(new Font("Dialog", Font.BOLD, 14));
         add(buttonCancel);
         buttonOk = new Button("Start agent server");
         buttonOk.addActionListener(this);
         if (server.serverRunning) {
            buttonOk.setLabel("Change name");
            setTitle("Change agent name");
         } else { setTitle("Setting agent parameters and start the server"); }
         buttonOk.setBounds(getInsets().left + 72,getInsets().top + 204,144,36);
         buttonOk.setFont(new Font("Dialog", Font.BOLD, 14));
         add(buttonOk);
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().getBounds();
    	Rectangle abounds = getBounds();
    	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);
    	super.show();
    }

    public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == buttonOk) {
	        buttonOk_Clicked();
        } else
        if (source == buttonCancel) {
            setVisible(false);
        }
	}

	void buttonOk_Clicked() {
        setVisible(false);
        server.nameAgent=textFieldAgent.getText();
		server.reg=Integer.parseInt(textFieldPort.getText());
		System.out.println("agentName="+textFieldAgent.getText());
		System.out.println("reg="+textFieldPort.getText());
		parentFrame.setTitle("            Distributed Agent Inteface   -   AGENTE   '"+server.nameAgent+"'");
		if (!server.serverRunning) {
          try {
            /* Avvio server agente */
            LocateRegistry.createRegistry(server.reg);
            String hostname="rmi://"+server.hostMachine+":"+server.reg+"/"+server.nameAgent;
            Naming.bind(hostname,server);
            parentFrame.buttonRun.enable();
            parentFrame.printMessage("Server "+textFieldAgent.getText()+" in ascolto su "+server.hostMachine+
                 ":"+server.reg+"\n");
            server.serverRunning=true;
           } catch (Exception e) {
              e.printStackTrace();
              DialogMessages d=new DialogMessages(parentFrame,true,"Impossibile far partire il server con i parametri inseriti");
              d.show();
              server.serverRunning=true;
            }
        }
        else {
          try {
            /* Se il server e' gia' in esecuzione viene ridefinito il legame nome_logico_host-->nome_server_agente */
            String hostname="rmi://"+server.hostMachine+":"+server.reg+"/"+server.nameAgent;
            Naming.rebind(hostname,server);
            } catch (Exception e) {e.printStackTrace();}
        }
    }

	Label labelAgent,labelPort,labelMachine1,labelMachine2;
    TextField textFieldAgent,textFieldPort;
	Button buttonCancel,buttonOk;
}
