/* classe che realizza la finestra di dialogo per l'eliminazione di un agente dal gruppo */

import java.awt.*;
import java.awt.event.*;

public class DialogRemove extends Dialog
         implements ActionListener {

    private int ind;
    private AgentFrame parent;
    private agentServer server;

	public DialogRemove(AgentFrame parent, agentServer server, boolean modal) {
        super(parent, modal);
        this.parent=parent;
        this.server=server;
		setLayout(null);
		addNotify();
		setSize(getInsets().left + getInsets().right + 647,getInsets().top + getInsets().bottom + 299);
		setFont(new Font("Dialog", Font.ITALIC, 16));
        setForeground(Color.black);
		setBackground(Color.lightGray);
		choiceAgent = new Choice();
		String agentName;
  		for (int i=0;i<server.numberOfAgent;i++) {
  		    agentName=server.otherMachine.elementAt(i)+"          "+server.otherAgentName.elementAt(i);
	    	choiceAgent.addItem(agentName);
		}
		add(choiceAgent);
		choiceAgent.setBounds(getInsets().left + 180,getInsets().top + 36,420,24);
		labelAgent = new Label("Select  the  agent");
		labelAgent.setBounds(getInsets().left + 12,getInsets().top + 36,156,30);
		setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelAgent);
		buttonOk = new Button("Ok");
		buttonOk.addActionListener(this);
		buttonOk.setBounds(getInsets().left + 168,getInsets().top + 204,108,37);
		buttonOk.setFont(new Font("Dialog", Font.BOLD, 16));
		add(buttonOk);
		buttonCancel = new Button("Cancel");
		buttonCancel.addActionListener(this);
		buttonCancel.setBounds(getInsets().left + 396,getInsets().top + 204,108,37);
		buttonCancel.setFont(new Font("Dialog", Font.BOLD, 16));
		add(buttonCancel);
		setTitle("   Remove an agent from the bunch");
	}

	public synchronized void show() {
    	Rectangle bounds = getParent().getBounds();
    	Rectangle abounds = getBounds();

    	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);
    	super.show();
    }

    public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == buttonOk) {
	        buttonOk_Clicked();
        } else
        if (source == buttonCancel) {
            setVisible(false);
        }
	}

	void buttonOk_Clicked() {
		setVisible(false);
		if (server.numberOfAgent>0) {
		  ind=choiceAgent.getSelectedIndex();
	      server.otherAgentName.removeElementAt(ind);
	      server.otherMachine.removeElementAt(ind);
	      server.otherRegistry.removeElementAt(ind);
	      server.numberOfAgent--;
	    }
	}

	//{{DECLARE_CONTROLS
	Label labelAgent;
	Choice choiceAgent;
	Button buttonOk,buttonCancel;
	//}}
}
