/* Procedura per l'aggiornamento della blackboad nel caso di politica read/write */
/* Il predicato aggiorna_write(Old,NewRes,NewList) controlla la consistenza ed   */
/* effettua l'aggiornamento della blackboard             */
/* Old = Lista abducibili presente nella blackboard  */
/* NewRes = Lista abducibili trovata da un certo agente */
/* NewList = Parametro di uscita: Lista abducibili da sostituire
             nella blackboard unione delle 2 precedenti se non ci
             sono incompatibilit                 */

aggiorna_write(Old,NewRes,NewList):-aggiorna_write_tail(Old,NewRes,[],NewList).

aggiorna_write_tail([],L,Current,Result):-!,append(L,Current,Result).

/*not(H) e' compatibile e non appartiene gi alla lista risultato */
aggiorna_write_tail([not(H)|Rest],NewRes,Current,NewList):-
             not(member(H,NewRes)),
             not(member(not(H),NewRes)),!,
             aggiorna_write_tail(Rest,NewRes,[not(H)|Current],NewList).

/*not(H) e' compatibile e appartiene gi alla lista risultato */
aggiorna_write_tail([not(H)|Rest],NewRes,Current,NewList):-!,
             not(member(H,NewRes)),
             aggiorna_write_tail(Rest,NewRes,Current,NewList).
/*altrimenti not(H) non e' compatibile */


/* H e' compatibile e non appartiene alla lista risultato  */
aggiorna_write_tail([H|Rest],NewRes,Current,NewList):-
             not(member(not(H),NewRes)),
             not(member(H,NewRes)),!,
             aggiorna_write_tail(Rest,NewRes,[H|Current],NewList).

/* H e' compatibile e  appartiene alla lista risultato */
aggiorna_write_tail([H|Rest],NewRes,Current,NewList):-!,
             not(member(not(H),NewRes)),
             aggiorna_write_tail(Rest,NewRes,Current,NewList).
/* altrimenti H non e' compatibile  */


member(X,[X|_]):-!.
member(X,[_|Z]:-member(X,Z).

append([],X,X).
append([A|X],Y,[A|Z]):-append(X,Y,Z).
